'ping_Vmtr2f.bas
'2-Kanal-Messung an ADC6 bzw. an ADC7
'Darstellung der Spannung mit zwei Ziffern hinter dem Dezimalpunkt
'Maximalwert hngt von Vcc ab
'Bei Schaltung mit Messbereichserweiterung grter
'Anzeigewert: 9,99V
'Verwendung von Teilen des Programmlistings LEDmatrix1.bas
'von Burkhard Kainka,vgl. dazu auch seine anderen Beitrge zur
'Programmierung des ATMEGA8 auf der Ping-Pong-Platine
'in BASCOM AVR unter www.elo-web.de
'Hermann Nieder
'Version 24.07.2011


$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim W As Word
Dim D As Byte
Dim N As Word

Dim X As Byte
Dim Y As Byte
Dim Dat As Long
Dim Dat6 As Long
Dim Dat7 As Long
Dim Dat14 As Word
Dim Dat1 As Word
Dim R_zehnt As Word
Dim R_hundert As Word
Dim Zeichen As Word
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt4 As Word
Dim Splt5 As Word
Dim Splt6 As Word
Dim Splt7 As Word
Dim Splt8 As Word
Dim Splt9 As Word
Dim Splt10 As Word
Dim Splt11 As Word
Dim Splt12 As Word
Dim Splt1_1 As Word
Dim Splt2_1 As Word
Dim Splt3_1 As Word
Dim J As Byte

Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)



Initialisierung

Dim Xx As Single
Dim Yy As Single


Anfang:
Dat = 0
'Eichen durch Vergleich mit AD-Wert von ADC14
'z. B. 1,23 V (vgl. Angaben in Datenblttern von 2004)
'Damit wird die Digital-Anzeige fast unabhngig von
'der Spannung Vcc

Dat14 = 0
Dat14 = Getadc(14)
'war Dat1=12300
Dat1 = 12500
Dat1 = Dat1 / Dat14
'Messungen
Do
If Pind.2 = 1 Then
Gosub Messen6
End If
If Pind.2 = 0 Then
Gosub Messen7
End If
Loop

Messen6:
Dat = 0
Dat6 = 0
For J = 1 To 10
Dat = Getadc(6)
Dat6 = Dat6 + Dat
Next J
Dat = Dat6 / 10

'siehe oben
Dat = Dat * Dat1
Dat = Dat / 10

Gosub Messw_anz
Return

Messen7:
Dat = 0
Dat7 = 0
For J = 1 To 10
Dat = Getadc(7)
Dat7 = Dat7 + Dat
Next J
Dat = Dat7 / 10

'siehe oben
Dat = Dat * 1000
Dat = Dat / Dat14
Gosub Messw_anz
Return

Messw_anz:
'Messbereichserweiterung um Faktor 3 bei
'PD.3 An Masse
If Pind.3 = 0 Then
Dat = Dat * 3
End If

'Einer

Zeichen = Dat / 1000

Gosub Darstellung1

R_zehnt = Dat Mod 1000

Zeichen = R_zehnt / 100
Gosub Darstellung2

'Zehntel
R_hundert = R_zehnt Mod 100

'Hundertstel
Zeichen = R_hundert / 10

Gosub Darstellung3

'Nun unten zustzlich die Einheit Volt darstellen
Gosub Darst_einheit

Waitms 1000
Return

'zustzlich Einheit Volt darstellen
Darst_einheit:
Leds(1) = Splt1_1 + 448
Leds(2) = Splt2_1 + 512
Leds(3) = Splt3_1 + 448


Leds(4) = 0
'Dezimalpunkt= 16
Leds(5) = 16 + 256
Leds(6) = 0 + 640

'2.Zeichen
Leds(7) = Splt7 + 256
Leds(8) = Splt8 + 448
Leds(9) = Splt9 + 512
'3.Zeichen
Leds(10) = Splt10 + 128
Leds(11) = Splt11 + 448
Leds(12) = Splt12 + 640
Return


'1. Zeichen links
Darstellung1:
Gosub Zeichen_z
Splt1_1 = Splt1
Splt2_1 = Splt2
Splt3_1 = Splt3
Leds(4) = 0
'Komma
Leds(5) = 24
Leds(6) = 0
Return
'2.Zeichen
Darstellung2:
Gosub Zeichen_z
Splt7 = Splt1
Splt8 = Splt2
Splt9 = Splt3
Return
'3.Zeichen
Darstellung3:
Gosub Zeichen_z
Splt10 = Splt1
Splt11 = Splt2
Splt12 = Splt3
Return

Zeichen_z:
'Fallunterscheidung fr Muster der Zeichen 0..9
Select Case Zeichen
Case 0:
Splt1 = 14
Splt2 = 17
Splt3 = 14
Case 1:
Splt1 = 0
Splt2 = 2
Splt3 = 31
Case 2:
Splt1 = 24
Splt2 = 21
Splt3 = 19
Case 3:
Splt1 = 17
Splt2 = 21
Splt3 = 27
Splt4 = 0
Case 4:
Splt1 = 7
Splt2 = 28
Splt3 = 4
Case 5:
Splt1 = 23
Splt2 = 21
Splt3 = 8
Case 6:
Splt1 = 14
Splt2 = 21
Splt3 = 8
Case 7:
Splt1 = 1
Splt2 = 29
Splt3 = 3
Case 8:
Splt1 = 10
Splt2 = 21
Splt3 = 10
Case 9:
Splt1 = 6
Splt2 = 21
Splt3 = 14
End Select

Return


Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = &B0011111                                  'gendert gegenber Vorlage
  Ddrb = &B11111111                                         'gendert gegenber Vorlage
  Ddrd = &B11110010                                         'Portd.2 -> Eingang
  'Config Portd = &B1111111
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2

  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc

  'Portd.2 = 1
 End Sub


'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte
Dim Portbout As Byte

Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portbout = &B00000000                                       '
Portb = Portbout
Portcout = &B00000000                                       '
Portc = Portcout
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And &B00111111                          '
Portdout = Portdout And &B11110110                          '
Portd = Portdout
Portc = Portcout
Portbout = High(leds(vy))                                   'And &B11111111                    'gendert
Portb = Portbout                                            'gendert
'Waitms 500
Return

End